package com.bonus.sgzb.system.api.factory;

import com.bonus.sgzb.system.api.domain.BmNumLogs;
import com.bonus.sgzb.base.api.domain.BmStorageLog;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;
import com.bonus.sgzb.common.core.domain.R;
import com.bonus.sgzb.system.api.RemoteLogService;
import com.bonus.sgzb.system.api.domain.SysLogininfor;
import com.bonus.sgzb.system.api.domain.SysOperLog;

import java.util.List;

/**
 * 日志服务降级处理
 * 
 * @author ruoyi
 */
@Component
public class RemoteLogFallbackFactory implements FallbackFactory<RemoteLogService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteLogFallbackFactory.class);

    @Override
    public RemoteLogService create(Throwable throwable)
    {
        log.error("日志服务调用失败:{}", throwable.getMessage());
        return new RemoteLogService()
        {
            @Override
            public R<Boolean> saveLog(SysOperLog sysOperLog, String source)
            {
                return R.fail("保存操作日志失败:" + throwable.getMessage());
            }

            @Override
            public R<Boolean> saveNumberLog(BmNumLogs bmNumLogs, String source) throws Exception {
                return R.fail("保存物资库存日志失败:" + throwable.getMessage());
            }

            @Override
            public R<Boolean> batchInsert(List<BmStorageLog> bmStorageLogList, String source) throws Exception {
                return R.fail("保存物资库存日志失败:" + throwable.getMessage());
            }

            @Override
            public R<Boolean> saveLogininfor(SysLogininfor sysLogininfor, String source)
            {
                return R.fail("保存登录日志失败:" + throwable.getMessage());
            }
        };

    }
}
